<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Adjustment extends MY_Controller {

	public function index()
	{
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			redirect('adjustment/request', 'refresh');
		}
		else {
			redirect('login', 'refresh');
		}
	}
	
	public function request()
	{
		save_current_url(base_url() . 'adjustment/request/');
		
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
			
			$data['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_adjustment') . ' - ' .$this->lang->line('hf_account_adjustment');
			
			$this->load->view('adjustment_request', $data);
		}
		else {
			redirect('login', 'refresh');
		}
	}
	
	public function submit()
	{
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			if($_POST) {
				$this->lang->load('account_general', get_language());
			
				$_POST['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_adjustment') . ' - ' .$this->lang->line('hf_account_adjustment');
			
				$this->load->model('user_model');
				
				$rs = $this->user_model->member_adjustment();
					
				if($rs) {
					redirect('adjustment/request/', 'refresh');
				}
				else {
					$this->load->view('adjustment_request', $_POST);
				}
			}
			else {
				redirect('adjustment/request/', 'refresh');
			}	
		}
		else {
			redirect('login', 'refresh');
		}
	}

	public function listing()
	{
		save_current_url(base_url() . 'adjustment/listing/');
		
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
			
			if($_POST) {
				$this->session->set_userdata(
					array(
						'member_search_username' => trim($this->input->post('search_username', TRUE)), 
						'member_search_downline' => trim($this->input->post('search_downline', TRUE)), 
						'member_exclude_downline' => trim($this->input->post('exclude_downline', TRUE)), 
						'member_search_adjustment_date' => trim($this->input->post('search_adjustment_date', TRUE)), 
						'member_search_start_date' => trim($this->input->post('search_start_date', TRUE)), 
						'member_search_end_date' => trim($this->input->post('search_end_date', TRUE)), 
						'member_search_member_type' => ($this->input->post('search_member_type', TRUE) != '') ? implode(',', $this->input->post('search_member_type', TRUE)) : '', 
						'member_search_wallet_type' => ($this->input->post('search_wallet_type', TRUE) != '') ? implode(',', $this->input->post('search_wallet_type', TRUE)) : '', 
						'member_search_remark' => trim($this->input->post('search_remark', TRUE))
						)
				);
				
				$_POST['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_adjustment') . ' - ' .$this->lang->line('hf_adjustment_history');
			
				$this->load->view('adjustment_history', $_POST);
			}
			else {
				$this->session->unset_userdata(array('member_search_username' => '', 'member_search_downline' => '', 'member_exclude_downline' => '', 'member_search_adjustment_date' => '', 'member_search_start_date' => '', 'member_search_end_date' => '', 'member_search_member_type' => '', 'member_search_wallet_type' => '', 'member_search_remark' => ''));
				
				$data['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_adjustment') . ' - ' .$this->lang->line('hf_adjustment_history');
				
				$this->load->view('adjustment_history', $data);
			}	
		}
		else {
			redirect('login', 'refresh');
		}
	}
	
	public function getlist()
    {
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
		
			/* Array of database columns which should be read and sent back to DataTables. Use a space where
			 * you want to insert a non-database field (for example a counter or static image)
			 */
			if($this->session->userdata('member_search_adjustment_date') != '') {
				$aColumns = array(
									$this->db->dbprefix('member_adjustment') . '.transaction_date',
									$this->db->dbprefix('member_adjustment') . '.transaction_type',
									$this->db->dbprefix('member_adjustment') . '.credit_amount',
									$this->db->dbprefix('member_adjustment') . '.to_member_username',
									$this->db->dbprefix('member_adjustment') . '.remark',
									$this->db->dbprefix('member_adjustment') . '.remark_2',
									$this->db->dbprefix('member_adjustment') . '.status'
								);
								
				$jColumns = $this->db->dbprefix('member_adjustment') . '.to_member_id = ' . $this->db->dbprefix('members') . '.member_id';				
			}
			else { 
				$aColumns = array(
									'transaction_date',
									'transaction_type',
									'credit_amount',
									'to_member_username',
									'remark',
									'remark_2',
									'status'
								);
			}	
			
			// DB table to use
			$sTable = 'member_adjustment';
			$jTable = 'members';
			//
			
			if($this->session->userdata('member_search_username') != '') {
				$where = $this->db->dbprefix('member_adjustment') . ".from_member_username = '" . $this->session->userdata('member_search_username') . "'";
				$this->db->where($where);
			}
			
			if($this->session->userdata('member_exclude_downline') != '') {
				$arr = explode(',', $this->session->userdata('member_exclude_downline'));
				$arr = implode("','", $arr);
				
				$query = $this->db->query("SELECT member_id FROM sw_members WHERE username IN('" . $arr . "')");
				if($query->num_rows > 0) {
					$where = '';
					foreach($query->result() as $row) {
						if($where != '') {
							$where .= " AND (" . $this->db->dbprefix('members') . ".introducer_parent_ref NOT LIKE '%," .  $row->member_id . ",%' AND " . $this->db->dbprefix('members') . ".member_id != " . $row->member_id . ")";
						}
						else {
							$where .= "(" . $this->db->dbprefix('members') . ".introducer_parent_ref NOT LIKE '%," .  $row->member_id . ",%' AND " . $this->db->dbprefix('members') . ".member_id != " . $row->member_id . ")";
						}
					}
					
					if($where != '') {
						$where = "(" . $where . ")";
						$this->db->where($where);
					}
				}
			}
			
			if($this->session->userdata('member_search_downline') != '') {
				$query = $this->db->query("SELECT member_id FROM sw_members WHERE username = ? LIMIT 1", array($this->session->userdata('member_search_downline')));
				if($query->num_rows() > 0) {
					$row = $query->row();
					$member_id = $row->member_id;
					$where = "(" . $this->db->dbprefix('members') . ".introducer_parent_ref LIKE '%,$member_id,%' OR " . $this->db->dbprefix('members') . ".member_id = $member_id)";
					$this->db->where($where);
				}
			}
			
			if($this->session->userdata('member_search_adjustment_date') != '') {
				if($this->session->userdata('member_search_adjustment_date') == 2) {
					$start_date = strtotime(date('Y-m-d 00:00:00', strtotime($this->session->userdata('member_search_start_date'))));
					$end_date = strtotime(date('Y-m-d 23:59:59', strtotime($this->session->userdata('member_search_end_date'))));
					$where = "(" . $this->db->dbprefix('member_adjustment') . ".transaction_date >= '" .  $start_date . "' AND " . $this->db->dbprefix('member_adjustment') . ".transaction_date <= '" .  $end_date . "')";
					$this->db->where($where);
				}
			}
			
			if($this->session->userdata('member_search_remark') != '') {
				$where = $this->db->dbprefix('member_adjustment') . ".remark = '" . $this->session->userdata('member_search_remark') . "'";
				$this->db->where($where);
			}
			
			if($this->session->userdata('member_search_member_type') != '') {
				$where = $this->db->dbprefix('members') . ".member_type IN(" .  $this->session->userdata('member_search_member_type') . ")";
				$this->db->where($where);
			}
			
			if($this->session->userdata('member_search_wallet_type') != '') {
				$where = $this->db->dbprefix('member_adjustment') . ".transaction_type IN(" .  $this->session->userdata('member_search_wallet_type') . ")";
				$this->db->where($where);
			}
			
			$iDisplayStart = $this->input->get_post('iDisplayStart', true);
			$iDisplayLength = $this->input->get_post('iDisplayLength', true);
			$iSortCol_0 = $this->input->get_post('iSortCol_0', true);
			$iSortingCols = $this->input->get_post('iSortingCols', true);
			$sSearch = $this->input->get_post('sSearch', true);
			$sEcho = $this->input->get_post('sEcho', true);
		
			// Paging
			if(isset($iDisplayStart) && $iDisplayLength != '-1')
			{
				$this->db->limit($this->db->escape_str($iDisplayLength), $this->db->escape_str($iDisplayStart));
			}
			
			// Ordering
			if(isset($iSortCol_0))
			{
				for($i=0; $i<intval($iSortingCols); $i++)
				{
					$iSortCol = $this->input->get_post('iSortCol_'.$i, true);
					$bSortable = $this->input->get_post('bSortable_'.intval($iSortCol), true);
					$sSortDir = $this->input->get_post('sSortDir_'.$i, true);
		
					if($bSortable == 'true')
					{
						$this->db->order_by($aColumns[intval($this->db->escape_str($iSortCol))], $this->db->escape_str($sSortDir));
					}
				}
			}
			
			/* 
			 * Filtering
			 * NOTE this does not match the built-in DataTables filtering which does it
			 * word by word on any field. It's possible to do here, but concerned about efficiency
			 * on very large tables, and MySQL's regex functionality is very limited
			 */
			if(isset($sSearch) && !empty($sSearch))
			{
				for($i=0; $i<count($aColumns); $i++)
				{
					$bSearchable = $this->input->get_post('bSearchable_'.$i, true);
					
					// Individual column filtering
					if(isset($bSearchable) && $bSearchable == 'true')
					{
						$this->db->or_like($aColumns[$i], $sSearch);
						// $this->db->or_like($aColumns[$i], $this->db->escape_like_str($sSearch));
					}
				}
			}
			
			// Select Data
			$this->db->select('SQL_CALC_FOUND_ROWS '.str_replace(' , ', ' ', implode(', ', $aColumns)), false);
			if($this->session->userdata('member_search_adjustment_date') != '') {
				$this->db->join($jTable, $jColumns);
			}
			$rResult = $this->db->get($sTable);
		
			// Data set length after filtering
			$this->db->select('FOUND_ROWS() AS found_rows');
			$iFilteredTotal = $this->db->get()->row()->found_rows;
		
			// Total data set length
			$iTotal = $this->db->count_all($sTable);
		
			// Output
			$output = array(
				'sEcho' => intval($sEcho),
				'iTotalRecords' => $iTotal,
				'iTotalDisplayRecords' => $iFilteredTotal,
				'aaData' => array()
			);
			
			foreach($rResult->result_array() as $aRow)
			{
				$row = array();
				
				$row[] = date('Y-m-d H:i:s', $aRow['transaction_date']);
				
				switch($aRow['transaction_type']) {
					case 4: $row[] = $this->lang->line('wallet_4'); break;
					case 3: $row[] = $this->lang->line('wallet_3'); break;
					case 2: $row[] = $this->lang->line('wallet_2'); break;
					default: $row[] = $this->lang->line('wallet_1'); break;
				}
				
				$row[] = number_format($aRow['credit_amount'], 2, '.', '');
				$row[] = $aRow['to_member_username'];
				$row[] = ($aRow['remark'] != '') ? $aRow['remark'] : '-';
				$row[] = ($aRow['remark_2'] != '') ? $aRow['remark_2'] : '-';
				switch($aRow['status']) {
					case 0: $row[] = '<span class="label label-info">' . $this->lang->line('adjustment_pending') . '</span>'; break;
					case 1: $row[] = '<span class="label label-success">' . $this->lang->line('adjustment_confirmed') . '</span>'; break;
					case 2: $row[] = '<span class="label label-success">' . $this->lang->line('adjustment_paid') . '</span>'; break;
					case 3: $row[] = '<span class="label label-important">' . $this->lang->line('adjustment_cancelled') . '</span>'; break;
					default: $row[] = '<span class="label label-info">' . $this->lang->line('adjustment_pending') . '</span>'; break;
				}
				
				$output['aaData'][] = $row;
			}
		
			echo json_encode($output);
		}	
    }
	
	public function adjustment_export()
	{
		set_time_limit(0);
		
		if($this->session->userdata('user_type') && ($this->session->userdata('user_type') == SUPERADMIN || $this->session->userdata('user_type') == ADMIN)) {
			$this->lang->load('account_general', get_language());
			
			require_once APPPATH."/third_party/php-excel.class.php";
			
			$data[] = array (
								$this->lang->line('adjustment_transaction_date'),
								$this->lang->line('adjustment_currency'),
								$this->lang->line('adjustment_amount'),
								$this->lang->line('adjustment_to_member'),
								$this->lang->line('adjustment_remark'),
								$this->lang->line('adjustment_remark') . ' 2',
								$this->lang->line('adjustment_status')
							);
			
			//Get Data
			if($this->session->userdata('member_search_adjustment_date') != '') {
				$aColumns = array(
									$this->db->dbprefix('member_adjustment') . '.transaction_date',
									$this->db->dbprefix('member_adjustment') . '.transaction_type',
									$this->db->dbprefix('member_adjustment') . '.credit_amount',
									$this->db->dbprefix('member_adjustment') . '.to_member_username',
									$this->db->dbprefix('member_adjustment') . '.remark',
									$this->db->dbprefix('member_adjustment') . '.remark_2',
									$this->db->dbprefix('member_adjustment') . '.status'
								);
								
				$jColumns = $this->db->dbprefix('member_adjustment') . '.to_member_id = ' . $this->db->dbprefix('members') . '.member_id';				
			}
			else { 
				$aColumns = array(
									'transaction_date',
									'transaction_type',
									'credit_amount',
									'to_member_username',
									'remark',
									'remark_2',
									'status'
								);
			}	
			
			// DB table to use
			$sTable = 'member_adjustment';
			$jTable = 'members';
			//
			
			if($this->session->userdata('member_search_username') != '') {
				$where = $this->db->dbprefix('member_adjustment') . ".from_member_username = '" . $this->session->userdata('member_search_username') . "'";
				$this->db->where($where);
			}
			
			if($this->session->userdata('member_exclude_downline') != '') {
				$arr = explode(',', $this->session->userdata('member_exclude_downline'));
				$arr = implode("','", $arr);
				
				$query = $this->db->query("SELECT member_id FROM sw_members WHERE username IN('" . $arr . "')");
				if($query->num_rows > 0) {
					$where = '';
					foreach($query->result() as $row) {
						if($where != '') {
							$where .= " AND (" . $this->db->dbprefix('members') . ".introducer_parent_ref NOT LIKE '%," .  $row->member_id . ",%' AND " . $this->db->dbprefix('members') . ".member_id != " . $row->member_id . ")";
						}
						else {
							$where .= "(" . $this->db->dbprefix('members') . ".introducer_parent_ref NOT LIKE '%," .  $row->member_id . ",%' AND " . $this->db->dbprefix('members') . ".member_id != " . $row->member_id . ")";
						}
					}
					
					if($where != '') {
						$where = "(" . $where . ")";
						$this->db->where($where);
					}
				}
			}
			
			if($this->session->userdata('member_search_downline') != '') {
				$query = $this->db->query("SELECT member_id FROM sw_members WHERE username = ? LIMIT 1", array($this->session->userdata('member_search_downline')));
				if($query->num_rows() > 0) {
					$row = $query->row();
					$member_id = $row->member_id;
					$where = "(" . $this->db->dbprefix('members') . ".introducer_parent_ref LIKE '%,$member_id,%' OR " . $this->db->dbprefix('members') . ".member_id = $member_id)";
					$this->db->where($where);
				}
			}
			
			if($this->session->userdata('member_search_adjustment_date') != '') {
				if($this->session->userdata('member_search_adjustment_date') == 2) {
					$start_date = strtotime(date('Y-m-d 00:00:00', strtotime($this->session->userdata('member_search_start_date'))));
					$end_date = strtotime(date('Y-m-d 23:59:59', strtotime($this->session->userdata('member_search_end_date'))));
					$where = "(" . $this->db->dbprefix('member_adjustment') . ".transaction_date >= '" .  $start_date . "' AND " . $this->db->dbprefix('member_adjustment') . ".transaction_date <= '" .  $end_date . "')";
					$this->db->where($where);
				}
			}
			
			if($this->session->userdata('member_search_remark') != '') {
				$where = $this->db->dbprefix('member_adjustment') . ".remark = '" . $this->session->userdata('member_search_remark') . "'";
				$this->db->where($where);
			}
			
			if($this->session->userdata('member_search_member_type') != '') {
				$where = $this->db->dbprefix('members') . ".member_type IN(" .  $this->session->userdata('member_search_member_type') . ")";
				$this->db->where($where);
			}
			
			if($this->session->userdata('member_search_wallet_type') != '') {
				$where = $this->db->dbprefix('member_adjustment') . ".transaction_type IN(" .  $this->session->userdata('member_search_wallet_type') . ")";
				$this->db->where($where);
			}
			
			$this->db->order_by($this->db->dbprefix('member_adjustment') . '.transaction_date', 'asc');
			
			$this->db->select('SQL_CALC_FOUND_ROWS '.str_replace(' , ', ' ', implode(', ', $aColumns)), false);
			if($this->session->userdata('member_search_adjustment_date') != '') {
				$this->db->join($jTable, $jColumns);
			}
			$rResult = $this->db->get($sTable);
			
			foreach($rResult->result_array() as $aRow)
			{
				$transaction_type = '';
				switch($aRow['transaction_type']) {
					case 4: $transaction_type = $this->lang->line('wallet_4'); break;
					case 3: $transaction_type = $this->lang->line('wallet_3'); break;
					case 2: $transaction_type = $this->lang->line('wallet_2'); break;
					default: $transaction_type = $this->lang->line('wallet_1'); break;
				}
				
				$status = '';
				switch($aRow['status']) {
					case 0: $status = $this->lang->line('adjustment_pending'); break;
					case 1: $status = $this->lang->line('adjustment_confirmed'); break;
					case 2: $status = $this->lang->line('adjustment_paid'); break;
					case 3: $status = $this->lang->line('adjustment_cancelled'); break;
					default: $status = $this->lang->line('adjustment_pending'); break;
				}
				
				$data[] = array (
									date('Y-m-d H:i:s', $aRow['transaction_date']),
									$transaction_type,
									number_format($aRow['credit_amount'], 2, '.', ''),
									$aRow['to_member_username'],
									(($aRow['remark'] != '') ? $aRow['remark'] : '-'),
									(($aRow['remark_2'] != '') ? $aRow['remark_2'] : '-'),
									$status
								);
			}
					
			$xls = new Excel_XML('UTF-8', false, 'Member Adjuestment List');
			$xls->addArray($data);
			$xls->generateXML('member_adjustment_list');
		}
	}
}

/* End of file adjustment.php */
/* Location: ./application/controllers/adjustment.php */